// Replaces the onSubmit attribute for the addRecord form.
function onSubmitLoad() {
  document.getElementById('searchButton').addEventListener('click',searchRecord);
  document.getElementById('addButton').addEventListener('click',addRecord);
  document.getElementById('updateButton').addEventListener('click',updateRecord);
  document.getElementById('deleteButton').addEventListener('click',deleteRecord);
}

function headerLoad() {
  let headerDiv = document.querySelector('#headerDiv');
  let headerDivHeight = headerDiv.offsetHeight;
  let headerNav = document.querySelector('#headerNav');
  let headerNavHeight = headerNav.offsetHeight;
  let pageHeaderHeight = headerDivHeight + headerNavHeight;
  document.getElementById("pageHeader").style.height = pageHeaderHeight + "px";
}

window.onscroll = function() {parallaxNavScroll()};

function parallaxNavScroll() {
  let headerDiv = document.querySelector('#headerDiv');
  let headerHeight = headerDiv.offsetHeight;
  if (document.body.scrollTop > headerHeight || document.documentElement.scrollTop > headerHeight) {
    document.getElementById("headerNav").style.top = "0";
    document.getElementById("headerNav").style.position = "fixed";
  } else {
    document.getElementById("headerNav").style.top = headerHeight + "px";
    document.getElementById("headerNav").style.position = "absolute";
  }
}

function pageLoad() {
  onSubmitLoad();
  headerLoad();
}

// Searches for a record in the database.
function searchRecord(e) {
  // Removes the standard form processing.
  e.preventDefault();
  e.stopPropagation();

  // Assigning form element values to variables.
  var recordName = document.getElementById("recordName").value;

  // Creating a form data-type to transfer multiple parameters to the server.
  var params = 'recordName='+recordName;

  var xhttp = new XMLHttpRequest();
  xhttp.open("POST", '/SearchRecord', true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.onreadystatechange = function() {
    if (xhttp.readyState === 4 && xhttp.status === 200) {
      console.log(xhttp.responseText);
      serverResponse = JSON.parse(xhttp.responseText);
      document.getElementById("recordName").value = serverResponse[0][0];
      document.getElementById("recordAddress").value = serverResponse[0][1];
      document.getElementById("recordMainPhotos").value = serverResponse[0][2];
      document.getElementById("recordAdditionalPhotos").value = serverResponse[0][3];
      document.getElementById("recordDescription").value = serverResponse[0][4];
      document.getElementById("recordWebsite").value = serverResponse[0][5];
      document.getElementById("recordEmail").value = serverResponse[0][6];
      document.getElementById("recordPhoneNumber").value = serverResponse[0][7];
      document.getElementById("recordOpeningHours").value = serverResponse[0][8];
      document.getElementById("recordCheckinInstructions").value = serverResponse[0][9];
      document.getElementById("DEBUGserverMessage").innerHTML = xhttp.responseText;
    } else {
      console.error(`Status Text: ${xhttp.statusText}.`);
      console.error(`Ready State: ${xhttp.readyState}.`);
    }
  };
  xhttp.send(params);
}

// Adds a record to the database.
function addRecord(e) {
  // Removes the standard form processing.
  e.preventDefault();
  e.stopPropagation();

  // Assigning form element values to variables.
  var recordName = document.getElementById("recordName").value;
  var recordAddress = document.getElementById("recordAddress").value;
  var recordMainPhotos = document.getElementById("recordMainPhotos").value;
  var recordAdditionalPhotos = document.getElementById("recordAdditionalPhotos").value;
  var recordDescription = document.getElementById("recordDescription").value;
  var recordWebsite = document.getElementById("recordWebsite").value;
  var recordEmail = document.getElementById("recordEmail").value;
  var recordPhoneNumber = document.getElementById("recordPhoneNumber").value;
  var recordOpeningHours = document.getElementById("recordOpeningHours").value;
  var recordCheckinInstructions = document.getElementById("recordCheckinInstructions").value;

  // Creating a form data-type to transfer multiple parameters to the server.
  var params = 'recordName='+recordName+'&recordAddress='+recordAddress+'&recordMainPhotos='+recordMainPhotos+'&recordAdditionalPhotos='+recordAdditionalPhotos+'&recordDescription='+recordDescription+'&recordWebsite='+recordWebsite+'&recordEmail='+recordEmail+'&recordPhoneNumber='+recordPhoneNumber+'&recordOpeningHours='+recordOpeningHours+'&recordCheckinInstructions='+recordCheckinInstructions;

  var xhttp = new XMLHttpRequest();
  xhttp.open("POST", '/AddRecord', true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.onreadystatechange = function() {
    if (xhttp.readyState === 4 && xhttp.status === 200) {
      console.log(xhttp.responseText);
      document.getElementById("DEBUGserverMessage").innerHTML = xhttp.responseText;
    } else {
      console.error(`Status Text: ${xhttp.statusText}.`);
      console.error(`Ready State: ${xhttp.readyState}.`);
    }
  };
  xhttp.send(params);
}

// Edits a record in the database.
function updateRecord(e) {
  // Removes the standard form processing.
  e.preventDefault();
  e.stopPropagation();

  // Assigning form element values to variables.
  var recordName = document.getElementById("recordName").value;
  var recordAddress = document.getElementById("recordAddress").value;
  var recordMainPhotos = document.getElementById("recordMainPhotos").value;
  var recordAdditionalPhotos = document.getElementById("recordAdditionalPhotos").value;
  var recordDescription = document.getElementById("recordDescription").value;
  var recordWebsite = document.getElementById("recordWebsite").value;
  var recordEmail = document.getElementById("recordEmail").value;
  var recordPhoneNumber = document.getElementById("recordPhoneNumber").value;
  var recordOpeningHours = document.getElementById("recordOpeningHours").value;
  var recordCheckinInstructions = document.getElementById("recordCheckinInstructions").value;

  // Creating a form data-type to transfer multiple parameters to the server.
  var params = 'recordName='+recordName+'&recordAddress='+recordAddress+'&recordMainPhotos='+recordMainPhotos+'&recordAdditionalPhotos='+recordAdditionalPhotos+'&recordDescription='+recordDescription+'&recordWebsite='+recordWebsite+'&recordEmail='+recordEmail+'&recordPhoneNumber='+recordPhoneNumber+'&recordOpeningHours='+recordOpeningHours+'&recordCheckinInstructions='+recordCheckinInstructions;

  var xhttp = new XMLHttpRequest();
  xhttp.open("POST", '/UpdateRecord', true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.onreadystatechange = function() {
    if (xhttp.readyState === 4 && xhttp.status === 200) {
      console.log(xhttp.responseText);
      document.getElementById("DEBUGserverMessage").innerHTML = xhttp.responseText;
    } else {
      console.error(`Status Text: ${xhttp.statusText}.`);
      console.error(`Ready State: ${xhttp.readyState}.`);
    }
  };
  xhttp.send(params);
}

// Deletes a record in the database.
function deleteRecord(e) {
  // Removes the standard form processing.
  e.preventDefault();
  e.stopPropagation();

  // Assigning form element values to variables.
  var recordName = document.getElementById("recordName").value;

  // Creating a form data-type to transfer multiple parameters to the server.
  var params = 'recordName='+recordName;

  var xhttp = new XMLHttpRequest();
  xhttp.open("POST", '/DeleteRecord', true);
  xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  xhttp.onreadystatechange = function() {
    if (xhttp.readyState === 4 && xhttp.status === 200) {
      console.log(xhttp.responseText);
      document.getElementById("DEBUGserverMessage").innerHTML = xhttp.responseText;
    } else {
      console.error(`Status Text: ${xhttp.statusText}.`);
      console.error(`Ready State: ${xhttp.readyState}.`);
    }
  };
  xhttp.send(params);
}
